package uk.kerb.sammy.pop
{
   import Box2D.Collision.Shapes.b2CircleDef;
   import Box2D.Common.Math.b2Vec2;
   import Box2D.Dynamics.b2Body;
   import Box2D.Dynamics.b2BodyDef;
   import Box2D.Dynamics.b2World;
   import flash.display.MovieClip;
   import flash.display.Sprite;
   import flash.events.Event;
   import uk.kerb.utils.AssetFactory;
   
   public class Ball
   {
      
      protected static const COLOUR_NAMES:Array = ["Red","Green","Blue","Yellow"];
      
      public static const COLOUR_YELLOW:int = 3;
      
      public static const COLOUR_BLACK:int = 4;
      
      public static const COLOUR_BLUE:int = 2;
      
      public static const COLOUR_GREEN:int = 1;
      
      public static const COLOUR_RED:int = 0;
      
      protected static const COLOURS:Array = [COLOUR_RED,COLOUR_GREEN,COLOUR_BLUE,COLOUR_YELLOW];
       
      
      protected const FRICTION:Number = 0;
      
      protected const DENSITY:Number = 1;
      
      protected const X_INIT_MIN:Number = 50;
      
      public var colour:int;
      
      protected const RESTITUTION:Number = 0;
      
      protected const RADIUS:Number = 16;
      
      protected var mc:MovieClip;
      
      protected const X_INIT:Array = [208,477,73,343];
      
      protected const X_INIT_MAX:Number = 500;
      
      public var body:b2Body;
      
      protected const Y_INIT:Number = -50;
      
      protected const X_INIT_DEVIATION:Number = 50;
      
      public function Ball(param1:b2World, param2:Sprite, param3:AssetFactory)
      {
         super();
         colour = COLOURS[Math.floor(Math.random() * COLOURS.length)];
         var _loc4_:String = "Ball" + COLOUR_NAMES[colour];
         var _loc5_:b2CircleDef;
         (_loc5_ = new b2CircleDef()).radius = RADIUS;
         _loc5_.density = DENSITY;
         _loc5_.friction = FRICTION;
         _loc5_.restitution = RESTITUTION;
         var _loc6_:b2BodyDef = new b2BodyDef();
         var _loc7_:Number;
         if((_loc7_ = Math.random() * 2 * X_INIT_DEVIATION - X_INIT_DEVIATION + X_INIT[colour]) < X_INIT_MIN)
         {
            _loc7_ = X_INIT_MIN;
         }
         else if(_loc7_ > X_INIT_MAX)
         {
            _loc7_ = X_INIT_MAX;
         }
         _loc6_.position.Set(_loc7_,Y_INIT);
         _loc6_.AddShape(_loc5_);
         mc = getMovieClip(_loc4_,param3);
         param2.addChild(mc);
         _loc6_.userData = mc;
         body = param1.CreateBody(_loc6_);
         var _loc8_:b2Vec2 = new b2Vec2(Math.random() * 200 - 100,0);
         body.SetLinearVelocity(_loc8_);
      }
      
      public function destroy() : void
      {
         mc.addEventListener(Event.ENTER_FRAME,onEnterFrame);
         mc.gotoAndPlay("pop");
      }
      
      protected function getMovieClip(param1:String, param2:AssetFactory) : MovieClip
      {
         return param2.createDisplayObject(param1) as MovieClip;
      }
      
      protected function onEnterFrame(param1:Event) : void
      {
         if(mc.currentFrame == mc.totalFrames)
         {
            mc.removeEventListener(Event.ENTER_FRAME,onEnterFrame);
            mc.parent.removeChild(mc);
         }
      }
   }
}
