package uk.kerb.sammy.pop
{
   import com.memecounter.Tracker;
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.events.IOErrorEvent;
   import flash.events.MouseEvent;
   import flash.net.URLLoader;
   import flash.net.URLRequest;
   import flash.net.navigateToURL;
   import uk.kerb.utils.AssetFactory;
   import uk.kerb.utils.Crypto;
   import uk.kerb.utils.sound.SoundManager;
   
   public class GameOver extends AbstractSection
   {
       
      
      private var score:Number;
      
      private var mc:MovieClip;
      
      public function GameOver()
      {
         super();
      }
      
      private function getSubmitURL() : String
      {
         var _loc1_:String = getBasePath();
         var _loc2_:* = _loc1_;
         _loc2_ += "setuserscore.php";
         _loc2_ += "?";
         _loc2_ += Main.PARAM_NAME_GAME;
         _loc2_ += "=";
         _loc2_ += escape(Crypto.encrypt(Main.GAME_ID));
         _loc2_ += "&";
         _loc2_ += Main.PARAM_NAME_SCORE;
         _loc2_ += "=";
         return _loc2_ + escape(Crypto.encrypt(score));
      }
      
      private function onLoadError(param1:Event) : void
      {
         trace("A load error has occurred.");
      }
      
      private function getHostFromBasePath(param1:String) : String
      {
         var _loc2_:int = 0;
         if(param1.indexOf("http://") == 0)
         {
            param1 = param1.substring(7);
            _loc2_ = param1.indexOf("/");
            if(_loc2_ >= 0)
            {
               param1 = param1.substring(0,_loc2_);
            }
         }
         return param1;
      }
      
      private function onRapClick(param1:MouseEvent) : void
      {
         Tracker.kvClick(Main.MEMECOUNTER_RAP_ATTACK_TRACKING);
         var _loc2_:URLRequest = new URLRequest(Main.BASE_PATH + "rap_attack.php");
         navigateToURL(_loc2_);
      }
      
      private function submitScore() : void
      {
         var url:String = getSubmitURL();
         var request:URLRequest = new URLRequest(url);
         var loader:URLLoader = new URLLoader();
         loader.addEventListener(IOErrorEvent.IO_ERROR,onLoadError);
         loader.addEventListener(Event.COMPLETE,onLoadComplete);
         try
         {
            loader.load(request);
         }
         catch(e:SecurityError)
         {
            trace("A security error has occurred.");
         }
      }
      
      private function onKillaClick(param1:MouseEvent) : void
      {
         Tracker.kvClick(Main.MEMECOUNTER_KILLAWATT_TRACKING);
         var _loc2_:URLRequest = new URLRequest(Main.BASE_PATH + "killawatt.php");
         navigateToURL(_loc2_);
      }
      
      private function onLoadComplete(param1:Event) : void
      {
      }
      
      private function getBasePath() : String
      {
         var _loc1_:* = Main.BASE_PATH;
         if(loaderInfo.parameters.basepath)
         {
            _loc1_ = String(loaderInfo.parameters.basepath);
         }
         if(_loc1_.charAt(_loc1_.length - 1) != "/")
         {
            _loc1_ += "/";
         }
         return _loc1_;
      }
      
      private function navigateToHighScores() : void
      {
         var _loc2_:String = null;
         var _loc3_:String = null;
         var _loc1_:String = getSubmitURL();
         _loc2_ = getBasePath();
         _loc3_ = getHostFromBasePath(_loc2_);
         var _loc4_:String = loaderInfo.url.indexOf(_loc3_) >= 0 ? "_self" : "_blank";
         var _loc5_:URLRequest = new URLRequest(_loc1_);
         navigateToURL(_loc5_,_loc4_);
      }
      
      override public function init(param1:AssetFactory) : void
      {
         super.init(param1);
         mc = param1.createDisplayObject("GameOverSection") as MovieClip;
         addChild(mc);
         addEventListener(Event.ENTER_FRAME,onEnterFrame);
      }
      
      private function onEnterFrame(param1:Event) : void
      {
         if(mc.screen_mc != null)
         {
            submitScore();
            mc.screen_mc.score_txt.text = score;
            mc.screen_mc.message_mc.gotoAndStop("gameComplete");
            mc.screen_mc.highScore_btn.addEventListener(MouseEvent.CLICK,onHighScoreClick);
            mc.screen_mc.playAgain_btn.addEventListener(MouseEvent.CLICK,onPlayAgainClick);
            mc.screen_mc.bat_btn.addEventListener(MouseEvent.CLICK,onBatClick);
            mc.screen_mc.rap_btn.addEventListener(MouseEvent.CLICK,onRapClick);
            mc.screen_mc.killa_btn.addEventListener(MouseEvent.CLICK,onKillaClick);
            mc.screen_mc.move_btn.addEventListener(MouseEvent.CLICK,onMoveClick);
            removeEventListener(Event.ENTER_FRAME,onEnterFrame);
         }
      }
      
      public function setScore(param1:Number) : void
      {
         this.score = param1;
      }
      
      private function onMoveClick(param1:MouseEvent) : void
      {
         Tracker.kvClick(Main.MEMECOUNTER_MOVE_ON_UP_TRACKING);
         var _loc2_:URLRequest = new URLRequest(Main.BASE_PATH + "move_on_up.php");
         navigateToURL(_loc2_);
      }
      
      private function onBatClick(param1:MouseEvent) : void
      {
         Tracker.kvClick(Main.MEMECOUNTER_BAT_OUT_OF_HELL_TRACKING);
         var _loc2_:URLRequest = new URLRequest(Main.BASE_PATH + "bat_out_of_hell.php");
         navigateToURL(_loc2_);
      }
      
      override public function destroy() : void
      {
         removeEventListener(Event.ENTER_FRAME,onEnterFrame);
         if(mc.screen_mc != null)
         {
            mc.screen_mc.highScore_btn.removeEventListener(MouseEvent.CLICK,onHighScoreClick);
            mc.screen_mc.playAgain_btn.removeEventListener(MouseEvent.CLICK,onPlayAgainClick);
            mc.screen_mc.bat_btn.removeEventListener(MouseEvent.CLICK,onBatClick);
            mc.screen_mc.rap_btn.removeEventListener(MouseEvent.CLICK,onRapClick);
            mc.screen_mc.killa_btn.removeEventListener(MouseEvent.CLICK,onKillaClick);
            mc.screen_mc.move_btn.removeEventListener(MouseEvent.CLICK,onMoveClick);
         }
      }
      
      private function onPlayAgainClick(param1:MouseEvent) : void
      {
         SoundManager.getInstance().getSoundFromID("button").play();
         Tracker.kvClick(Main.MEMECOUNTER_PLAYAGAIN_TRACKING);
         dispatchEvent(new Event(Event.COMPLETE));
      }
      
      override public function getNextSection() : Class
      {
         return GetReady;
      }
      
      private function onHighScoreClick(param1:MouseEvent) : void
      {
         SoundManager.getInstance().getSoundFromID("button").play();
         Tracker.kvClick(Main.MEMECOUNTER_HIGHSCORE_TRACKING);
         navigateToHighScores();
      }
   }
}
