package uk.kerb.sammy.pop
{
   import Box2D.Collision.Shapes.b2BoxDef;
   import Box2D.Dynamics.b2Body;
   import Box2D.Dynamics.b2BodyDef;
   import Box2D.Dynamics.b2World;
   import flash.display.Graphics;
   import flash.events.TimerEvent;
   import flash.utils.Timer;
   import flash.utils.getTimer;
   
   public class Line
   {
      
      public static const LIVE_LINE_COLOUR:uint = 15804281;
      
      public static const HAIR_THICKNESS:Number = 2;
      
      public static const MAX_HAIR_LENGTH:Number = 3;
      
      public static const LINE_THICKNESS:Number = 8;
      
      public static const DEAD_LINE_COLOUR:uint = 16751001;
       
      
      private var timer:Timer;
      
      private const LIFESPAN:int = 1200;
      
      private const RESTITUTION:Number = 0.5;
      
      private var timestamp:int;
      
      private var y0:int;
      
      private var y1:int;
      
      private var body:b2Body;
      
      private var dead:Boolean;
      
      private var dist:Number;
      
      private var x0:int;
      
      private var x1:int;
      
      private const FRICTION:Number = 0;
      
      public function Line(param1:int, param2:int, param3:int, param4:int, param5:b2World)
      {
         super();
         this.x0 = param1;
         this.y0 = param2;
         this.x1 = param3;
         this.y1 = param4;
         dead = false;
         var _loc6_:Number = param3 - param1;
         var _loc7_:Number = param4 - param2;
         dist = Math.sqrt(_loc6_ * _loc6_ + _loc7_ * _loc7_);
         var _loc8_:Number = 0.5 * (param1 + param3);
         var _loc9_:Number = 0.5 * (param2 + param4);
         var _loc10_:b2BoxDef;
         (_loc10_ = new b2BoxDef()).extents.Set(0.5 * dist,0.5 * LINE_THICKNESS);
         _loc10_.friction = FRICTION;
         _loc10_.restitution = RESTITUTION;
         var _loc11_:b2BodyDef;
         (_loc11_ = new b2BodyDef()).position.Set(_loc8_,_loc9_);
         _loc11_.rotation = Math.atan2(_loc7_,_loc6_);
         _loc11_.AddShape(_loc10_);
         body = param5.CreateBody(_loc11_);
         timer = new Timer(LIFESPAN,1);
         timer.addEventListener(TimerEvent.TIMER,onTimer);
         timer.start();
         timestamp = getTimer();
      }
      
      public function destroy(param1:b2World) : void
      {
         param1.DestroyBody(body);
      }
      
      public function draw(param1:Graphics) : void
      {
         var _loc2_:Number = NaN;
         var _loc3_:Number = NaN;
         var _loc4_:Number = NaN;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc8_:int = 0;
         var _loc7_:Number = MAX_HAIR_LENGTH * (1 - (getTimer() - timestamp) / LIFESPAN);
         _loc8_ = 0;
         while(_loc8_ < dist)
         {
            _loc2_ = (x1 - x0) * (_loc8_ / dist) + x0;
            _loc3_ = (y1 - y0) * (_loc8_ / dist) + y0;
            _loc4_ = Math.random() * 2 * _loc7_ - _loc7_;
            _loc5_ = Math.random() * 2 * _loc7_ - _loc7_;
            param1.moveTo(_loc2_ - _loc4_,_loc3_ - _loc5_);
            param1.lineTo(_loc2_ + _loc4_,_loc3_ + _loc5_);
            _loc8_++;
         }
      }
      
      private function onTimer(param1:TimerEvent) : void
      {
         timer.removeEventListener(TimerEvent.TIMER,onTimer);
         dead = true;
      }
      
      public function isDead() : Boolean
      {
         return dead;
      }
   }
}
