package uk.kerb.sammy.pop
{
   import com.memecounter.Tracker;
   import com.viralchart.ViralTracker;
   import flash.display.Loader;
   import flash.display.MovieClip;
   import flash.display.Sprite;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.net.URLRequest;
   import uk.kerb.utils.AssetFactory;
   import uk.kerb.utils.sound.*;
   
   public final class Main extends Sprite
   {
      
      public static const MUSIC_CREDIT_TRACKING:String = "http://watches.whodidit.co.uk/watch86.swf";
      
      public static const MEMECOUNTER_RAP_ATTACK_TRACKING:int = 496;
      
      public static const GAME_ID:int = 5;
      
      public static const VIRAL_CHART_TRACKING:int = 790;
      
      public static const MEMECOUNTER_NEOLICIOUS_TRACKING:int = 480;
      
      public static const BASE_PATH:String = "http://sammysgamebox.com/";
      
      public static const PARAM_NAME_GAME:String = "gameid";
      
      public static const MEMECOUNTER_MOVE_ON_UP_TRACKING:int = 493;
      
      public static const PARAM_NAME_SCORE:String = "score";
      
      public static const MEMECOUNTER_CAMPAIGN_ID:int = 384;
      
      public static const NEOLICIOUS_LINK:String = "http://neolicious.com/index.htm#artist_4";
      
      public static const WHODIDIT_TRACKING:String = "http://watches.whodidit.co.uk/watch90.swf";
      
      public static const MEMECOUNTER_HIGHSCORE_TRACKING:int = 642;
      
      public static const MEMECOUNTER_KILLAWATT_TRACKING:int = 494;
      
      public static const MEMECOUNTER_PLAYAGAIN_TRACKING:int = 643;
      
      public static const MEMECOUNTER_BAT_OUT_OF_HELL_TRACKING:int = 492;
       
      
      private var sm:SoundManager;
      
      private var currentSection:AbstractSection;
      
      private var sound_btn:MovieClip;
      
      private var assetFactory:AssetFactory;
      
      public function Main(param1:Class)
      {
         super();
         assetFactory = new AssetFactory();
         assetFactory.addEventListener(AssetFactory.EVENT_ASSET_FACTORY_READY,onAssetFactoryReady);
         assetFactory.initialize(param1);
      }
      
      private function gotoSection(param1:Class) : void
      {
         var _loc2_:Number = NaN;
         if(param1 == null)
         {
            return;
         }
         if(currentSection != null)
         {
            if(currentSection is Game)
            {
               _loc2_ = (currentSection as Game).getScore();
            }
            currentSection.removeEventListener(Event.COMPLETE,onSectionComplete);
            currentSection.destroy();
            removeChild(currentSection);
         }
         currentSection = new param1();
         currentSection.init(assetFactory);
         currentSection.addEventListener(Event.COMPLETE,onSectionComplete);
         if(currentSection is GameOver)
         {
            (currentSection as GameOver).setScore(_loc2_);
         }
         addChild(currentSection);
         setChildIndex(sound_btn,numChildren - 1);
         stage.frameRate = param1 == Game ? 60 : 25;
      }
      
      private function onSectionComplete(param1:Event) : void
      {
         gotoSection(currentSection.getNextSection());
      }
      
      private function onAssetFactoryReady(param1:Event) : void
      {
         assetFactory.removeEventListener(AssetFactory.EVENT_ASSET_FACTORY_READY,onAssetFactoryReady);
         init();
      }
      
      private function init() : void
      {
         var _loc2_:ExtendedSound = null;
         Tracker.init(root,MEMECOUNTER_CAMPAIGN_ID);
         ViralTracker.track(VIRAL_CHART_TRACKING,root);
         var _loc1_:Loader = new Loader();
         _loc1_.load(new URLRequest(WHODIDIT_TRACKING));
         sm = SoundManager.getInstance();
         _loc2_ = assetFactory.createSound("Music") as ExtendedSound;
         sm.registerSound(_loc2_,"music");
         _loc2_ = assetFactory.createSound("SFXBallCorrect") as ExtendedSound;
         sm.registerSound(_loc2_,"ballCorrect");
         _loc2_ = assetFactory.createSound("SFXBallWrong") as ExtendedSound;
         sm.registerSound(_loc2_,"ballWrong");
         _loc2_ = assetFactory.createSound("SFXBlackBall") as ExtendedSound;
         sm.registerSound(_loc2_,"blackBall");
         _loc2_ = assetFactory.createSound("SFXBlackBallPop") as ExtendedSound;
         sm.registerSound(_loc2_,"blackBallPop");
         _loc2_ = assetFactory.createSound("SFXButton") as ExtendedSound;
         sm.registerSound(_loc2_,"button");
         _loc2_ = assetFactory.createSound("SFXPoints") as ExtendedSound;
         sm.registerSound(_loc2_,"points");
         _loc2_ = assetFactory.createSound("SFXWin") as ExtendedSound;
         sm.registerSound(_loc2_,"win");
         sound_btn = assetFactory.createDisplayObject("SoundButton") as MovieClip;
         sound_btn.x = stage.stageWidth - sound_btn.width - 6;
         sound_btn.y = stage.stageHeight - sound_btn.height - 6;
         sound_btn.buttonMode = true;
         sound_btn.useHandCursor = true;
         sound_btn.mute_mc.gotoAndStop(1);
         sound_btn.addEventListener(MouseEvent.MOUSE_DOWN,onToggleSound);
         addChild(sound_btn);
         gotoSection(Title);
      }
      
      private function onToggleSound(param1:MouseEvent) : void
      {
         param1.stopPropagation();
         if(sm.muted)
         {
            sm.unmute();
         }
         else
         {
            sm.mute();
         }
         if(sound_btn.mute_mc != null)
         {
            sound_btn.mute_mc.gotoAndStop(sm.muted ? 2 : 1);
         }
      }
   }
}
