package uk.kerb.sammy.pop
{
   import flash.display.Sprite;
   import flash.events.Event;
   import flash.events.TimerEvent;
   import flash.utils.Timer;
   import flash.utils.getTimer;
   import uk.kerb.utils.AssetFactory;
   
   public class ScoreMessage extends Sprite
   {
       
      
      private var amplitude:Number = 15;
      
      private var timer:Timer;
      
      private const lifespan:int = 2000;
      
      private var initX:Number;
      
      private var initY:Number;
      
      private var startTime:int;
      
      private const dy:Number = 200;
      
      private var scoreSprite:Sprite;
      
      private const frequency:Number = 12.566370614359172;
      
      private const minScale:Number = 0.3;
      
      public function ScoreMessage(param1:Number, param2:Number, param3:Number, param4:AssetFactory)
      {
         var _loc5_:String = null;
         super();
         initX = param1;
         initY = param2;
         this.x = initX;
         this.y = initY;
         if(param3 < 0)
         {
            _loc5_ = "Minus" + Math.abs(param3);
         }
         else
         {
            _loc5_ = param3.toString();
         }
         scoreSprite = param4.createDisplayObject("Score" + _loc5_) as Sprite;
         if(scoreSprite != null)
         {
            addChild(scoreSprite);
            scoreSprite.cacheAsBitmap = true;
            timer = new Timer(lifespan,1);
            timer.addEventListener(TimerEvent.TIMER,onTimer);
            timer.start();
            startTime = getTimer();
            addEventListener(Event.ENTER_FRAME,onEnterFrame);
         }
      }
      
      private function onEnterFrame(param1:Event) : void
      {
         var _loc2_:Number = (getTimer() - startTime) / lifespan;
         y = initY - _loc2_ * dy;
         _loc2_ = 1 - _loc2_;
         x = _loc2_ * amplitude * Math.sin(frequency * _loc2_) + initX;
         scoreSprite.alpha = _loc2_;
         scoreSprite.scaleX = _loc2_ * (1 - minScale) + minScale;
         scoreSprite.scaleY = scoreSprite.scaleX;
      }
      
      public function destroy() : void
      {
         if(parent != null)
         {
            parent.removeChild(this);
         }
         timer.removeEventListener(TimerEvent.TIMER,onTimer);
         removeEventListener(Event.ENTER_FRAME,onEnterFrame);
      }
      
      private function onTimer(param1:TimerEvent) : void
      {
         timer.removeEventListener(TimerEvent.TIMER,onTimer);
         parent.removeChild(this);
      }
   }
}
